#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include "xmd.h"

#define MYLINUX 9          /* AMD5x86 133MHz -> 9 sec */
#define MYLINUX_WAIT 300000 

void speed(void){
  time_t time1, time2;
  long exetime;
  float ratio;
  long i;

  printf("\nPlease wait for 10sec.");
  printf("\nnow testing machine speed... ");
  fflush(stdout);
  time1 = time(NULL);
  for(i=0; i<100000000; i++);
  time2 = time(NULL);
  printf("done.\n");

  exetime = time2 - time1;
  if(exetime == 0)
    exetime = 1;
  ratio = (float) MYLINUX / exetime;
  if(ratio > 10.0)
    ratio = 10.0;

  WAIT = MYLINUX_WAIT * ratio;
  RAG = WAIT * 4.2;                   /* x4.5 ha ososugita node */

  printf("wait = %d\n", WAIT / 10000);

}





