#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#define DEL_NUM 3
#define FORTEST 1           /* 0 is for test , 1 is normal value*/
#define AppClass "Xmd"
#define YOKO 8
#define TATE 11
#define CHAR_COLOR "brown"
#define BGCOLOR "orange"

char *cantput = "Can't put Drop! (Full)";

Widget canvas;
int map[YOKO][TATE];
int map_last[YOKO][TATE];
int sabun[YOKO][TATE];

int penalty[11] = {0,0,1,1,2,3,4,4,5,5,6};
                   /*  ^---- 2 rensa   /  max 10 rensa */
struct _mychar{
  int x;         /* x is 0 to YOKO-1 (x zahyou) */
  int color;
  int number;
  int zanzou;    /* animation color name */
  int amari;
}mychar;

int st = 0;       /* st  = STATUS, ta = TARGET */
int ta = -1;      /* target '-1' = random */

int mypd;
int yabasa[10];
char servername[100];
char mynick[10];
int score;
int persons = 0;
int winner;
char nicknames[10][10];
int port = 4170;

Display *disp;
Colormap cmap;
XColor color, def, xcolor[7], pad, canvas_bg;
GC gc1;
XtAppContext app_con;
Widget toplevel, form, names, canvas2, start, message;
Widget form2, status_l, status, target_l, target, tama_l, tama, title;
                                                 /* hoge_l means 'label' */
Widget keybind, toggle1, toggle2;
Widget popup_shell, replay_dialog, big;

XtIntervalId id_timerequest;
XtInputId selectid;


int WAIT, RAG;

char *Version = "X Magical Dron ver. 1.13 / Team Ayanami 1997 ";

char *col[]={
  "red",
  "green",
  "blue",
  "yellow",
  "gold",   /* kieru */
  "white"   /* kuru */
};


String namelist[15];  
int fd;
int interval = 7000;  /*  max 7000(ms)
			  min 1500(ms)  */
int kiepuyo = 0;


void delete(void);
void v_init(void);
void cannotput(void);
void delete_stab(void);
void Param(int, char**);
int sconnect(void);

void mystate(XtPointer, XtIntervalId *);
void timerequest(XtPointer, XtIntervalId *);
void mystate_refresh(XtPointer, XtIntervalId *);
XtInputCallbackProc xselect(XtPointer, int *, XtInputId *);


void draw(Widget w){
  int i, j, k, drawcolor;
  Dimension width, height, w1, h1;

  XtVaGetValues(w, 
		XtNwidth, &width,
		XtNheight, &height,
		NULL);
  w1 = width / YOKO; 
  h1 = height / TATE; 

  for(k=0; k<2; k++){
  for(i=0; i<YOKO; i++){ 
    for(j=0; j<TATE; j++){

      if(map[i][j] != map_last[i][j]){
	drawcolor = map[i][j];
	if(drawcolor == -1){
	  XSetForeground(disp, gc1, canvas_bg.pixel);
	}else{
	  if(map[i][j] > 5 || map[i][j] < -1){
	    fprintf(stderr,"illegal clolr! col.no. = %d\n",map[i][j]);
	    map[i][j]=0;
	  }
	  XSetForeground(disp, gc1, xcolor[map[i][j]].pixel);
	}
	XFillArc(XtDisplay(w), XtWindow(w), gc1,
		 w1*i, h1*j, 
		 w1, h1,
		 0, 360*64);
      }
    }
  }
  }

  for(i=0; i<YOKO; i++)
    for(j=0; j<TATE; j++)
      map_last[i][j] = map[i][j];

  XSync(XtDisplay(w), FALSE);
}


void redraw(Widget w){
  int i, j;

  if(w == canvas){
    if(st!=0){
      XClearWindow(XtDisplay(canvas), XtWindow(canvas));
      for(i=0; i<YOKO; i++)
	for(j=0; j<TATE; j++)
	  map_last[i][j] = 100; /* dummy */
      draw(canvas);
    }
  }
}


static void draw2(Widget w){
  int i, j;
  Dimension width, height, w1, h1;

  if(w == canvas2){

    XClearWindow(XtDisplay(w), XtWindow(w));
    XtVaGetValues(w, 
		  XtNwidth, &width,
		  NULL);
    XtVaGetValues(canvas,
		  XtNheight, &height,
		  NULL);

    w1 = width / YOKO; 
    h1 = height / TATE; 


    XSetForeground(disp, gc1, pad.pixel);
    XFillRectangle(XtDisplay(w), XtWindow(w), gc1, 
		   w1*(mychar.x), h1*3, w1, h1/3);

    if(mychar.zanzou != -1){
      XSetForeground(disp, gc1, xcolor[mychar.color].pixel);
      XFillArc(XtDisplay(w), XtWindow(w), gc1, 
	       w1*(mychar.x), 0,
	       w1, h1,
	       0, 360*64);
    }


    if(mychar.color != -1){
      XSetForeground(disp, gc1, xcolor[mychar.color].pixel);
      XFillArc(XtDisplay(w), XtWindow(w), gc1, 
	       w1*(mychar.x), h1*2,
	       w1, h1,
	       0, 360*64);
    }
    XSync(XtDisplay(w), FALSE);
  }
}  

void bigscreen(Widget w, XtPointer client_data, XtPointer call_data){

  XtResizeWidget(toplevel, 600, 800, 1);

  redraw(canvas);
  draw2(canvas2);


}

void gamestart(Widget w, XtPointer client_data, XtPointer call_data){
  char tmp[80];

  if(st == 0){
    if(persons >= 2){
      sprintf(tmp,"START;\0");
      write(fd,tmp,strlen(tmp)); 
      XtVaSetValues(status,
		    XtNlabel, "Game",
		    NULL);
    }else{
      XtVaSetValues(message,
		    XtNlabel, "Too few players! Can't start!",
		    NULL);
    }
  }


}


static void okurisaki(Widget w, XEvent *ev, String *who ){
  int i,j;
  char tmp[13];

  for(i=0; i<persons; i++){

    sprintf(tmp,"%d",i);
    if(strcmp(tmp,*who) == 0){

      strncpy(tmp, namelist[i+2], 12);  /* namelist[0],[1] is title */
      tmp[12] = '\0';

      XtVaSetValues(target,
		    XtNlabel, tmp,
		    NULL);
      ta = i;
      break;
    }

  }
  if(strcmp("r",*who)==0){
    XtVaSetValues(target,
		  XtNlabel, "Random", 
		  NULL);
    ta = -1;
  }

}


static void get(Widget w){
  int wait;
  int i = 0;
  int j = mychar.x;
  char tmp[10], messagebox[100];

if(st == FORTEST){


  XtVaGetValues(message,
		XtNlabel, messagebox,
		NULL);
  if(strcmp(messagebox, cantput) == 0){   /* if message box is can't put */
    XtVaSetValues(message,
		  XtNlabel, "",
		  NULL);
    /* delete message box */
  }


  while(map[j][i] != -1 && i<TATE)
    i++;

  if(i != 0){
    i--;
    if(map[j][i] == mychar.color || mychar.color == -1){

      /* get! */

      /* onazi iro ha ikkini get! */
      
      do{
	(mychar.number)++;
	mychar.color = map[j][i];
	map[j][i] = -1;
	i--;
      }while(i >= 0 && map[j][i] == mychar.color);

      draw(canvas);
      mychar.zanzou = mychar.color;
      draw2(canvas2);

      sprintf(tmp,"%d",mychar.number);
      XtVaSetValues(tama,
		    XtNlabel, tmp,
		    NULL);


      for(wait=0; wait<WAIT; wait++);

      mychar.zanzou = -1;
      draw2(canvas2);
    }
  }

} /* st != 2 nara nanimo shinai */

}

static void put(Widget w){
  int wait;
  int k, l, number;
  int i = TATE - 1;   /* sita kara siraberu */
  int j = mychar.x;
  int topcol, already = 0;         /* sudeni ikutsu tunagatte iruka */
  int kieru = 0;      /* Zero means FALSE */

  char tmp[10];
  char messagebox[100];

if(st == FORTEST){

  XtVaGetValues(message,
		XtNlabel, messagebox,
		NULL);
  if(strcmp(messagebox, cantput) == 0){   /* if message box is can't put */
    XtVaSetValues(message,
		  XtNlabel, "",
		  NULL);
    /* delete message box */
  }




  if(mychar.number != 0){

    while(map[j][i] == -1 && i>=0)
      i--;

    l = i;
    topcol = map[j][l];
    while(map[j][l] == topcol && l>=0){
      already++;
      l--;
    }

    number = mychar.number;
    if(i >= TATE - 1){
      /* NG 1*/
      cannotput();
    }else if(topcol != mychar.color && 
	     number < DEL_NUM && 
	     i + number >= TATE){
      /* NG 2*/
      cannotput();
    }else if(topcol == mychar.color && 
	     i + number >= TATE &&
	     already + number < DEL_NUM){
      /* NG 3*/
      cannotput();
    }else{
      /* PUT OK! */
      mychar.amari = number - (TATE - 1 - i);
      if(mychar.amari < 0) 
	mychar.amari = 0;
      number = number - mychar.amari;

      if(topcol == mychar.color && already + number + mychar.amari >= DEL_NUM){
	kieru = 1;
      }else if(topcol != mychar.color && number + mychar.amari >= DEL_NUM){
	kieru = 1;
      }

      
      for(k = 0; k < number; k++){
	(mychar.number)--;
	map[j][i+1+k] = mychar.color;
      }

      mychar.number = 0;
      mychar.color = -1;

      sprintf(tmp,"%d",mychar.number);
      XtVaSetValues(tama,
		    XtNlabel, tmp,
		    NULL);

      draw2(canvas2);

      if(kieru == 1){

	delete();
	mychar.amari = 0;
      }

      draw(canvas);
    }
  }

}  /* st != 2 ----> nanimo sinai */

}


void cannotput(void){
  XtVaSetValues(message,
		XtNlabel, cantput,
		NULL);
}

void xmdconnect(void){
  char tmp[80];

  fd = sconnect();          /* connection estublish */
  sprintf(tmp,"NICK:%s;\0",mynick);
  write(fd,tmp,strlen(tmp));
}


static void move(Widget w, XEvent *ev, String *dir){
  if(strcmp("L",*dir) == 0)
    (mychar.x)--;
  else
    (mychar.x)++;

  if(mychar.x < 0)
    mychar.x = YOKO - 1;
  else if(mychar.x > YOKO-1 )
    mychar.x = 0;             /* Char move --- Loop */

  draw2(canvas2);
}

void keychange(Widget w, XtPointer num, XtPointer call_data){

  XtTranslations translations;

  char key[1000];
 
  if((int)num == 1){
    strcpy(key,
    "<Expose>: redraw() draw2()\n\
     <Configure>: redraw() draw2()\n\
     None<Key>0: okurisaki(0)\n\
     None<Key>1: okurisaki(1)\n\
     None<Key>2: okurisaki(2)\n\
     None<Key>3: okurisaki(3)\n\
     None<Key>4: okurisaki(4)\n\
     None<Key>5: okurisaki(5)\n\
     None<Key>6: okurisaki(6)\n\
     None<Key>7: okurisaki(7)\n\
     None<Key>8: okurisaki(8)\n\
     None<Key>9: okurisaki(9)\n\
     None<Key>r: okurisaki(r)\n\
     None<Key>d: move(L)\n\
     None<Key>f: move(R)\n\
     None<Key>j: get()\n\
     None<Key>k: put()");
  }else{
    strcpy(key,
    "<Expose>: redraw() draw2()\n\
     <Configure>: redraw() draw2()\n\
     None<Key>0: okurisaki(0)\n\
     None<Key>1: okurisaki(1)\n\
     None<Key>2: okurisaki(2)\n\
     None<Key>3: okurisaki(3)\n\
     None<Key>4: okurisaki(4)\n\
     None<Key>5: okurisaki(5)\n\
     None<Key>6: okurisaki(6)\n\
     None<Key>7: okurisaki(7)\n\
     None<Key>8: okurisaki(8)\n\
     None<Key>9: okurisaki(9)\n\
     None<Key>r: okurisaki(r)\n\
     None<Key>Left: move(L)\n\
     None<Key>Right: move(R)\n\
     None<Key>Down: get()\n\
     None<Key>Up: put()");
  }

  translations = XtParseTranslationTable(key);

  XtUninstallTranslations(canvas);
  XtOverrideTranslations(canvas, translations);
  XtUninstallTranslations(canvas2);
  XtOverrideTranslations(canvas2, translations);
  XtUninstallTranslations(message);
  XtOverrideTranslations(message, translations);
  XtUninstallTranslations(names);
  XtOverrideTranslations(names, translations);
  XtUninstallTranslations(form2);
  XtOverrideTranslations(form2, translations);
  XtUninstallTranslations(status_l);
  XtOverrideTranslations(status_l, translations);
  XtUninstallTranslations(status);
  XtOverrideTranslations(status, translations);
  XtUninstallTranslations(target_l);
  XtOverrideTranslations(target_l, translations);
  XtUninstallTranslations(target);
  XtOverrideTranslations(target, translations);
  XtUninstallTranslations(tama_l);
  XtOverrideTranslations(tama_l, translations);
  XtUninstallTranslations(tama);
  XtOverrideTranslations(tama, translations);
  XtUninstallTranslations(keybind);
  XtOverrideTranslations(keybind, translations);
  XtUninstallTranslations(title);
  XtOverrideTranslations(title, translations);

  XtOverrideTranslations(toggle1, translations);
  XtOverrideTranslations(toggle2, translations);
  XtOverrideTranslations(start, translations);
  XtOverrideTranslations(big, translations);

}

void yn_yes(Widget w, XtPointer dummy){

  XtPopdown(popup_shell);

  /* global hensu initialize! */
     v_init();

  xmdconnect();

  XtRemoveInput(selectid);

  selectid = XtAppAddInput(app_con, fd, 
			   (XtPointer)XtInputReadMask, 
			   (XtInputCallbackProc)xselect, 
			   toplevel); 

}

void yn_no(Widget w, XtPointer dummy){
  printf("\nThank you! (X magical dron / Team Ayanami)\n");
  exit(0);
}

void v_init(void){
  int i, j;
  char tmp[20];

  st=0;
  XtVaSetValues(status,
		XtNlabel,"Wait",
		NULL);
  ta=-1;
  XtVaSetValues(target,
		XtNlabel,"Random",
		NULL);

  XtVaSetValues(tama,
		XtNlabel,"0",
		NULL);

  XtVaSetValues(message,
		XtNlabel,"",
		NULL);
  
  persons = 0;
  interval = 7000;
  kiepuyo = 0;

  mychar.x = YOKO - 1;
  mychar.color = -1;
  mychar.number = 0;
  mychar.zanzou = -1;
  mychar.amari = 0;


  strcpy(namelist[0], "Player's nick/status");
  strcpy(namelist[1], " ");

  for(i=2; i<=11; i++){
    sprintf(tmp,"%d: ",i-2);
    strcpy(namelist[i], tmp);
  }
  
  strcpy(namelist[12], " ");
  strcpy(namelist[13], "R: Random");
  namelist[14]= NULL;

  XawListChange(names, namelist, 0, 0, False);

  for(i=0; i<YOKO; i++){
    for(j=0; j<TATE; j++){
      map_last[i][j] = -1;   
      map[i][j] = -1;
    }
  } 

  XClearWindow(XtDisplay(canvas), XtWindow(canvas));
  XClearWindow(XtDisplay(canvas2), XtWindow(canvas2));

  for(i=0; i<10; i++)
    strcpy(nicknames[i], "NOUSE");

  for(i=0; i<10; i++)
    yabasa[i] = TATE - 4;

  XtRemoveTimeOut(id_timerequest);

}
  

main(int argc, char **argv){

  int i,j;
  char tmp[20];
  char bg[80];

  static String fallback[] = {
    "*translations: #override \\n\
     <Expose>: redraw() draw2()\\n\
     <Configure>: redraw() draw2()\\n\
     None<Key>0: okurisaki(0)\\n\
     None<Key>1: okurisaki(1)\\n\
     None<Key>2: okurisaki(2)\\n\
     None<Key>3: okurisaki(3)\\n\
     None<Key>4: okurisaki(4)\\n\
     None<Key>5: okurisaki(5)\\n\
     None<Key>6: okurisaki(6)\\n\
     None<Key>7: okurisaki(7)\\n\
     None<Key>8: okurisaki(8)\\n\
     None<Key>9: okurisaki(9)\\n\
     None<Key>r: okurisaki(r)\\n\
     None<Key>d: move(L)\\n\
     None<Key>f: move(R)\\n\
     None<Key>j: get()\\n\
     None<Key>k: put()",
/*
     None<Key>Left: move(L)\\n\
     None<Key>Right: move(R)\\n\
     None<Key>z: get()\\n\
     None<Key>x: put()\\n\
     None<Key>Down: get()\\n\
     None<Key>Up: put()",
*/
    "*title.justify: center",

    "*canvas.background: orange",
    "*canvas.fromVert: title",

    "*message.fromVert: canvas",
    "*canvas2.fromVert: message",
    "*canvas2.background: orange",

    "*names.fromVert: title",
    "*names.fromHoriz: canvas",    
    "*form2.fromVert: names",
    "*form2.fromHoriz: message",

    "*title.borderWidth: 0",
    "*start.label: Start!",
    "*start.borderWidth: 1",
    "*big.label: Big screen",
    "*start.borderWidth: 1",
    "*canvas.width: 300",
    "*canvas.height: 430",

    "*names.width: 150",
    "*names.height: 400", 
    "*names.rowSpacing: 12",

    "*names.defaultColumns: 1",
    "*names.forceColumns: TRUE",
    "*message.label: ",
    "*message.width: 300",
    "*canvas2.width: 300",
    "*canvas2.height: 170",

    "*status_l.borderWidth: 0",
    "*status_l.label: YOUR STATUS",

    "*status.width: 140",
    "*status.fromVert: status_l",
    "*status.label: Wait",

    "*target_l.borderWidth: 0",
    "*target_l.fromVert: status",
    "*target_l.label: TARGET",

    "*target.width: 140",
    "*target.fromVert: target_l",
    "*target.label: Random",

    "*tama_l.borderWidth: 0",
    "*tama_l.fromVert: target",
    "*tama_l.label: TAMA",

    "*tama.width: 140",
    "*tama.fromVert: tama_l",
    "*tama.label: 0",

    "*keybind.borderWidth: 0",
    "*keybind.fromVert: tama",
    "*keybind.label: Keybind",

    "*toggle1.borderWidth: 1",
    "*toggle1.fromVert: keybind",
    "*toggle1.label: Default",
    "*toggle1.state: True",

    "*toggle2.borderWidth: 1",
    "*toggle2.fromVert: toggle1",
    "*toggle2.label: Cursor-key",
    "*toggle2.radioGroup: toggle1",

    "*big.fromVert: toggle1",
    "*big.vertDistance: 47",
    "*big.horizDistance: 40",

    "*start.fromVert: big",
    "*start.horizDistance: 55",

    "*replay_dialog.label: Replay [y/n]?",
    "*replay.width: 200",
    "*replay.height: 50",
    "*replay_yes.label: Yes",
    "*replay_no.label: No",

    NULL
  };

  static XtActionsRec actions[] = {
    {"redraw", (XtActionProc)redraw},
    {"draw2", (XtActionProc)draw2},
    {"okurisaki", (XtActionProc)okurisaki},
    {"move", (XtActionProc)move},
    {"get", (XtActionProc)get},
    {"put", (XtActionProc)put}
  };


  Param(argc, argv);        /* paramater analysis */


  toplevel = XtVaAppInitialize(&app_con, AppClass, NULL, 0, 
			       &argc, argv, fallback, NULL);


  disp = XtDisplay(toplevel);
  cmap = DefaultColormap(disp, 0);
  gc1 = XCreateGC(disp, RootWindow(disp,0), 0, NULL);

  for(i=0; i<6; i++){
    if(XAllocNamedColor(disp, cmap, col[i], &xcolor[i], &def) == 0){
      fprintf(stderr,"Can't allocate color '%s'. exit.\n", col[i]);
      exit(1);
    }
  }
  XAllocNamedColor(disp, cmap, CHAR_COLOR, &pad, &def);

  if(XAllocNamedColor(disp, cmap, BGCOLOR, &canvas_bg, &def)==0){
    fprintf(stderr,"Can't allocate color '%s'. exit.\n", BGCOLOR);
    exit(1);
  }

  xmdconnect();                /* connect to server */

  form = XtVaCreateManagedWidget("form",
 				 formWidgetClass, toplevel, NULL);
  title = XtVaCreateManagedWidget("title",
				  labelWidgetClass, form, NULL);
  canvas = XtVaCreateManagedWidget("canvas",
				   widgetClass, form, NULL);
  names = XtVaCreateManagedWidget("names",
				  listWidgetClass, form, NULL);
  message = XtVaCreateManagedWidget("message",
				    labelWidgetClass, form, NULL);
  canvas2 = XtVaCreateManagedWidget("canvas2",
				    widgetClass, form, NULL);
  form2 = XtVaCreateManagedWidget("form2",
				  formWidgetClass, form, NULL);
  status_l = XtVaCreateManagedWidget("status_l",
				  labelWidgetClass, form2, NULL);
  status = XtVaCreateManagedWidget("status",
				  labelWidgetClass, form2, NULL);
  target_l = XtVaCreateManagedWidget("target_l",
				  labelWidgetClass, form2, NULL);
  target = XtVaCreateManagedWidget("target",
				  labelWidgetClass, form2, NULL);
  tama_l = XtVaCreateManagedWidget("tama_l",
				  labelWidgetClass, form2, NULL);
  tama = XtVaCreateManagedWidget("tama",
				  labelWidgetClass, form2, NULL);
  keybind = XtVaCreateManagedWidget("keybind",
				  labelWidgetClass, form2, NULL);
  toggle1 = XtVaCreateManagedWidget("toggle1",
				  toggleWidgetClass, form2, NULL);
  toggle2 = XtVaCreateManagedWidget("toggle2",
				  toggleWidgetClass, form2, NULL);


  big = XtVaCreateManagedWidget("big",
				   commandWidgetClass, form2, NULL);
  start = XtVaCreateManagedWidget("start",
				   commandWidgetClass, form2, NULL);

  popup_shell = XtVaCreatePopupShell("replay",
				     topLevelShellWidgetClass, toplevel,NULL);
  replay_dialog = XtVaCreateManagedWidget("replay_dialog",
				    dialogWidgetClass, popup_shell, NULL);

  XawDialogAddButton(replay_dialog, "replay_yes",
		     (XtCallbackProc)yn_yes, NULL);
  XawDialogAddButton(replay_dialog, "replay_no",
		     (XtCallbackProc)yn_no, NULL);  
  

  XtVaSetValues(title,
		XtNlabel, Version,
		XtNwidth, 454,
		NULL);

  mychar.x = YOKO - 1;
  mychar.color = -1;
  mychar.number = 0;
  mychar.zanzou = -1;
  mychar.amari = 0;


  for(i=0; i<=14; i++)
    namelist[i] = (char *)malloc(sizeof(char) * 21);


  strcpy(namelist[0], "Player's nick/status");
  strcpy(namelist[1], " ");

  for(i=2; i<=11; i++){
    sprintf(tmp,"%d: ",i-2);
    strcpy(namelist[i], tmp);
  }
  
  strcpy(namelist[12], " ");
  strcpy(namelist[13], "R: Random");
  namelist[14]= NULL;

  XawListChange(names, namelist, 0, 0, True);

  for(i=0; i<YOKO; i++){
    for(j=0; j<TATE; j++){
      map_last[i][j] = -1;   
      map[i][j] = -1;
    }
  }


  for(i=0; i<10; i++)
    strcpy(nicknames[i], "NOUSE");

  for(i=0; i<10; i++)
    yabasa[i] = TATE - 4;


  XtAppAddActions(app_con, actions, XtNumber(actions));

  XtAddCallback(start, XtNcallback, gamestart, (XtPointer)&fd);
  XtAddCallback(big, XtNcallback, bigscreen, NULL);
  XtAddCallback(toggle1, XtNcallback, keychange, (XtPointer)1);
  XtAddCallback(toggle2, XtNcallback, keychange, (XtPointer)2);

  XtAppAddTimeOut(app_con, 5000,
		  mystate,
		  (XtPointer)NULL);

  XtAppAddTimeOut(app_con, 1000,
		  mystate_refresh,
		  (XtPointer)NULL);

  selectid = XtAppAddInput(app_con, fd, 
			   (XtPointer)XtInputReadMask, 
			   (XtInputCallbackProc)xselect, 
			   toplevel); 
                        /* toplevel is dummy */

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_con);

}
